/* 

                          Firewall Builder

                 Copyright (C) 2001 Vadim Kurland

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: CustomService.hh,v 1.2 2001/09/21 18:40:44 lord Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/




#ifndef __CUSTOMSERVICE_HH_FLAG__
#define __CUSTOMSERVICE_HH_FLAG__

#include "FWObject.hh"

#include <map>

namespace libfwbuilder
{

class CustomService : public FWObject 
{
    
    private:
    
    map<string,string>   codes;
    
    public:
    
    CustomService();
    virtual ~CustomService();
    
    virtual void       fromXML(xmlNodePtr parent);
    virtual xmlNodePtr toXML(xmlNodePtr parent);
    
    virtual FWObject& operator=(const FWObject &);
    
    DECLARE_FWOBJECT_SUBTYPE(CustomService);

    void setCodeForPlatform(const string& platform, const string& code);
    const string& getCodeForPlatform(const string& platform);
};

}

#endif




