/* 

                          Firewall Builder

                 Copyright (C) 2000 Vadim Kurland

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: Firewall.hh,v 1.2 2001/09/21 18:40:44 lord Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#ifndef __FIREWALL_HH_FLAG__
#define __FIREWALL_HH_FLAG__

#include "Host.hh"

namespace libfwbuilder
{

class FirewallOptions;
class Policy;
class NAT;

class Firewall : public Host 
{
    
    protected:
    
    public:
    
    Firewall();
    virtual ~Firewall();
    
    virtual void fromXML(xmlNodePtr parent);
    virtual xmlNodePtr toXML      (xmlNodePtr parent);
    
    
    DECLARE_FWOBJECT_SUBTYPE(Firewall);
    
    /**
     * verify whether given object type is approppriate as a child
     */
    virtual bool    validateChild(FWObject *o);

    /**
     *  This method sets default values to the platform-specific
     *  firewall parameters. It makes changes only to those parameters
     *  which are not defined yet; this makes it safe to call this
     *  method often, for example every time user changes firewall
     *  platform in the dialog.  Since this method would not reset
     *  those parameters which have already been set, user won't lose
     *  parameters values switching to another platform and then back
     *  again.
     */
    void    setDefaults();

    /**
     *  This method returns reference to the object representing
     *  firewall's platform-specific options (class FirewallOptions)
     */
    FirewallOptions* getOptionsObject();

    Policy  *getPolicy();
    NAT     *getNAT();
};

}

#endif //__FIREWALL_HH_FLAG__
